﻿using System;

namespace BoasPraticas.CodigoBom
{
    public class CalculoDescontoStatusContaFactory : ICalculoDescontoStatusContaFactory
    {
        public ICalculoDesconto GetCalculoDescontoStatusConta(StatusDaConta statusDaConta)
        {

            ICalculoDesconto calcular;

            switch (statusDaConta)
            {
                case StatusDaConta.NaoRegistrado:
                    calcular = new ClienteNaoRegistradoDesconto();
                    break;
                case StatusDaConta.ClienteComum:
                    calcular = new ClienteComumDesconto();
                    break;
                case StatusDaConta.ClienteEspecial:
                    calcular = new ClienteEspecialDesconto();
                    break;
                case StatusDaConta.ClienteVIP:
                    calcular = new ClienteVIPDesconto();
                    break;
                default:
                    throw new NotImplementedException();
            }
            return calcular;

        }
    }
}
